(**************************************************************************)
(*  Burfiks: bayesian filter for the web                                  *)
(*                                                                        *)
(*  (c) Copyright 2007, INRIA                                             *)
(*                                                                        *)
(*  Authors:                                                              *)
(*  --------                                                              *)
(*  Francesco Zappa Nardelli (INRIA, Rocquencourt)                        *)
(*  Patala Arun Kumar (IIT Kanpur)                                        *)
(*  Sanchit Garg (IIT Bombay)                                             *)
(*  Vidyut Ghosal (IIT Kanpur)                                            *)
(*                                                                        *)
(*  This file is distributed under the terms of the GNU Public License    *)
(*  version 2, http://www.gnu.org/licenses/gpl-2.0.txt                    *)
(*                                                                        *)
(**************************************************************************)

let active_debug = ref []
let active_debug_all = ref false

let debug l s =
  if (List.mem l !active_debug) || (!active_debug_all)
  then ( print_string ("*** "^l^" : "^s);
	 flush stdout )
  else ()

let warning s =
  print_endline ("+ "^s)

let try_finalize f x finally y =
  let res = try f x with exn -> finally y; raise exn in
  finally y;
  res

let rec but_last l =
  match l with
  | [] -> []
  | h::[] -> []
  | h::tl -> h::(but_last tl)

(* FIXME *)
let rec verify_dir s =
  if not(Sys.file_exists s)
  then begin
    let par_dir = Filename.dirname s in
    verify_dir par_dir;
    Unix.mkdir s 0o777;
  end

let verify_file s =
  if not(Sys.file_exists s) 
  then begin
    let dir = Filename.dirname s in
    verify_dir dir;
    Unix.close (Unix.openfile s [ Unix.O_CREAT; Unix.O_WRONLY ] 0o600);
  end



